import { ListenerRegistry } from "./util/ListenerRegistry";
import { ComponentName, IEntity } from "./World";
export declare type ArchetypeQuery<T extends IEntity> = {
    all?: ComponentName<T>[];
    any?: ComponentName<T>[];
    none?: ComponentName<T>[];
};
export declare class Archetype<T extends IEntity> {
    query: ArchetypeQuery<T>;
    /** A list of entities belonging to this archetype. */
    entities: T[];
    /** Listeners on this event are invoked when an entity is added to this archetype's index. */
    onEntityAdded: ListenerRegistry<(entity: T) => void>;
    /** Listeners on this event are invoked when an entity is removed from this archetype's index. */
    onEntityRemoved: ListenerRegistry<(entity: T) => void>;
    constructor(query: ArchetypeQuery<T>);
    indexEntity(entity: T): void;
    removeEntity(entity: T): void;
}
