import { FC } from "react";
import { ArchetypeQueryOrComponentList, UntypedEntity, World } from ".";
import { IEntity } from "./World";
/**
 * Create various React-specific hooks and components for your
 * Miniplex ECS instance.
 *
 * @param world An instance of a Miniplex ECS to use.
 */
export declare function createReactIntegration<T extends IEntity = UntypedEntity>(world: World<T>): {
    useArchetype: (...query: ArchetypeQueryOrComponentList<T>) => T[];
    useEntity: () => T;
    Entity: FC<{
        entity?: T | undefined;
    }>;
    Component: <K extends keyof T>({ name, data }: {
        name: K;
        data: T[K];
    }) => null;
};
